function Occupations
clear; close all; clc;

load bhps_data; 
% clean and organize data
missing =     X(:,2)==0; X(missing==1,:)=[]; 
missing = isnan(X(:,2)); X(missing==1,:)=[]; 
%coding = input('soc90, soc00, or both (answer 1,2,3) '); soc90 = X(:,3)<=10; soc00=X(:,3)>10; 
%if coding==1 X(soc00==1,:)=[]; end
%if coding==2 X(soc90==1,:)=[]; end
ind=X(:,1); % individual
occ=X(:,2); % occupation
per=X(:,3); % year 
group = input('# of digit classification level '); % select classification level (1, 2, or 3)
if group==3,                                   end
if group==2, occ = occ/10 ;  occ = floor(occ); end 
if group==1, occ = occ/100;  occ = floor(occ); end 
% correct for apparent coding errors
if group==2,  drop = occ==18 | occ==98;                                         end
if group==3,  errors = setdiff(unique(occ),SOC3D); drop = ismember(occ,errors); end 
if group~=1,  ind(drop==1)=[]; occ(drop==1)=[]; per(drop==1)=[];                end   
% relabeling for consistency
if group==1, common = num2str([1:1:9]');             for c=1:size(common,1), names{c} = common(c,:); end; end
if group==2, common = num2str(intersect(occ,SOC2D)); for c=1:size(common,1), names{c} = common(c,:); end; end
if group==3, common = num2str(intersect(occ,SOC3D)); for c=1:size(common,1), names{c} = common(c,:); end; end
% relabel units
i = ind; j = occ; ij = [i j];
[newi, ii] = sort(i); d = [1;diff(newi)]; d = d>0; newi = cumsum(d); ij(ii,1) = newi;
[newj, jj] = sort(j); d = [1;diff(newj)]; d = d>0; newj = cumsum(d); ij(jj,2) = newj;
i = ij(:,1); j = ij(:,2); 
clear ii jj ij d newi newj;
ii= unique(i); n1 = size(ii,1);
jj= unique(j); n2 = size(jj,1);

% weighted adjacency matrix
A = zeros(n2,n2); 
for j1 = 1:n2
    for j2=j1+1:n2
        ind1 = i(j==j1); ind2 = i(j==j2); obs = intersect(ind1,ind2); nobs = length(obs);   
        if nobs==0, continue; end
        for i0 = 1:nobs
            unit = obs(i0);
            d0(i0)  = sum(i==unit)      ; 
            m01(i0) = sum(ind1==unit); 
            m02(i0) = sum(ind2==unit);
        end
         A(j1,j2) = sum((m01.*m02)./d0);
         A(j2,j1) = sum((m01.*m02)./d0); clear d0 m01 m02;
    end
end

% construct weighted graph from A
H = graph(A,names);
bins = conncomp(H); % find connected components in the total graph
G = subgraph(H,bins==1); % largest connected component

% construct all matrices from G
nn = numnodes(G); [s,t] = findedge(G); A = sparse(s,t,G.Edges.Weight,nn,nn); 
A = A + A.' - diag(diag(A)); C = A~=0; 
d = sum(A,2); D = diag(d); Dinv = diag(sqrt(1./d)); L = D-A; S = Dinv*L*Dinv; % L_star = Dinv*pinv(Dinv*L*Dinv)*Dinv;

% compute eigenvalues of S
ev = eig(S); evs = sort(ev); lambda2 = evs(2),

% compute harmonic means
omega =  1/nn      ; hinv  = sum(omega./d        ,1); h = 1./hinv , dd = d *ones(1,nn);
omega = (A.^2)./dd      ; hiinv = sum(omega./dd'      ,2); hi= 1./hiinv; hh = hi*ones(1,nn);
omega = C.*(hh./dd); Hiinv = sum(omega./(dd.*hh)',2); Hi= 1./Hiinv; 
omega =  h/nn      ; Hinv  = sum(omega./(d.*hi)  ,1); H = 1./Hinv ,

if group==1, save bhps_data_graph_1D; end
if group==2, save bhps_data_graph_2D; end
if group==3, save bhps_data_graph_3D; end






