function TeacherValueAdded
clear; close all; clc;

load teachers_read;

% relabel teacher ids from 1 to n
i = sender; j = receiver; ij = [i j]; 
[newi ii] = sort(i); d = [1;diff(newi)]; d=d>0; newi = cumsum(d); ij(ii,1) = newi;
[newj jj] = sort(j); d = [1;diff(newj)]; d=d>0; newj = cumsum(d); ij(jj,2) = newj;
i = ij(:,1); j = ij(:,2); 
clear ii jj ij d newi newj;
ii= unique(i); n = size(ii,1);

% set up the graph and identify main connected component
H = graph(i,j,weight,'OmitSelfLoops'); % set up weighted graph for teachers
bins = conncomp(H); % find connected components in the total graph
G = subgraph(H,bins==1); % largest connected component

% construct all matrices from G
nn = numnodes(G); [s,t] = findedge(G); A = sparse(s,t,G.Edges.Weight,nn,nn); 
A = A + A.' - diag(diag(A)); C = A~=0; 
d = sum(A,2); D = diag(d); Dinv = diag(sqrt(1./d)); L = D-A; S = Dinv*L*Dinv; L_star = Dinv*pinv(Dinv*L*Dinv)*Dinv;


% compute eigenvalues of S
ev = eig(S); evs = sort(ev); lambda2 = evs(2),

% compute harmonic means
omega =  1/nn      ; hinv  = sum(omega./d        ,1); h = 1./hinv , dd = d *ones(1,nn);
omega = (A.^2)./dd      ; hiinv = sum(omega./dd'      ,2); hi= 1./hiinv; hh = hi*ones(1,nn);
omega = C.*(hh./dd); Hiinv = sum(omega./(dd.*hh)',2); Hi= 1./Hiinv; 
omega =  h/nn      ; Hinv  = sum(omega./(d.*hi)  ,1); H = 1./Hinv ,

save teachers_read_graph;



